<!DOCTYPE html>
<html class="writer-html5" lang="en" data-content_root="../../">
<head>
  <meta charset="utf-8" /><meta name="viewport" content="width=device-width, initial-scale=1" />

  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>Scenario API Support &mdash; openPASS Documentation</title>
      <link rel="stylesheet" type="text/css" href="../../_static/pygments.css?v=b86133f3" />
      <link rel="stylesheet" type="text/css" href="../../_static/css/theme.css?v=19f00094" />
      <link rel="stylesheet" type="text/css" href="../../_static/css/custom.css?v=4ad39fc2" />

  
    <link rel="shortcut icon" href="../../_static/openPASS.ico"/>
  <!--[if lt IE 9]>
    <script src="../../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script src="../../_static/jquery.js?v=5d32c60e"></script>
        <script src="../../_static/_sphinx_javascript_frameworks_compat.js?v=2cd50e6c"></script>
        <script src="../../_static/documentation_options.js?v=6efca38a"></script>
        <script src="../../_static/doctools.js?v=888ff710"></script>
        <script src="../../_static/sphinx_highlight.js?v=dc90522c"></script>
    <script src="../../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="Scenery" href="scenery.html" />
    <link rel="prev" title="Scenario" href="scenario.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >

          
          
          <a href="../../index.html" class="icon icon-home">
            openPASS
              <img src="../../_static/openPASS.png" class="logo" alt="Logo"/>
          </a>
              <div class="version">
                1.2.0
              </div>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" aria-label="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <p class="caption" role="heading"><span class="caption-text">Installation Guide</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/10_getting_started.html">Getting Started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/15_system_requirements.html">System Requirements</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/20_install_prerequisites.html">Installing Prerequisites</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/30_install_openpass.html">Installing openPASS</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/50_further_guidance.html">Further Guidance</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/60_conan.html">Building with Conan</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">User Guides</span></p>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="../10_overview.html">Overview</a></li>
<li class="toctree-l1"><a class="reference internal" href="../20_tutorials.html">Tutorials</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="../30_configs_in_depth.html">Configs in Depth</a><ul class="current">
<li class="toctree-l2"><a class="reference internal" href="profilescatalog.html">ProfilesCatalog</a></li>
<li class="toctree-l2"><a class="reference internal" href="scenario.html">Scenario</a></li>
<li class="toctree-l2 current"><a class="current reference internal" href="#">Scenario API Support</a><ul>
<li class="toctree-l3"><a class="reference internal" href="#igeometryhelper">IGeometryHelper</a></li>
<li class="toctree-l3"><a class="reference internal" href="#ienvironment">IEnvironment</a></li>
<li class="toctree-l3"><a class="reference internal" href="#icoordconverter">ICoordConverter</a></li>
<li class="toctree-l3"><a class="reference internal" href="#ilanelocationqueryservice">ILaneLocationQueryService</a></li>
<li class="toctree-l3"><a class="reference internal" href="#icontrollerrepository">IControllerRepository</a></li>
<li class="toctree-l3"><a class="reference internal" href="#ientity">IEntity</a></li>
<li class="toctree-l3"><a class="reference internal" href="#ivehicle">IVehicle</a></li>
<li class="toctree-l3"><a class="reference internal" href="#ipedestrian">IPedestrian</a></li>
<li class="toctree-l3"><a class="reference internal" href="#istaticobject">IStaticObject</a></li>
<li class="toctree-l3"><a class="reference internal" href="#ientityrepository">IEntityRepository</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="scenery.html">Scenery</a></li>
<li class="toctree-l2"><a class="reference internal" href="simulationconfig.html">SimulationConfig</a></li>
<li class="toctree-l2"><a class="reference internal" href="staticsystemconfig.html">Static SystemConfig</a></li>
<li class="toctree-l2"><a class="reference internal" href="systemconfigblueprint.html">SystemConfigBlueprint</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../40_outputs_in_depth.html">Outputs in Depth</a></li>
<li class="toctree-l1"><a class="reference internal" href="../50_scenario_simulation.html">Simulator</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Advanced topics</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../advanced_topics/20_simulator_advanced.html">Simulator</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../advanced_topics/30_testing.html">EndToEnd Test Framework</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Developer Information</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../developer_information/10_ide_support.html">IDE Support</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../developer_information/20_documentation.html">Documentation Concept</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../developer_information/30_coding_conventions.html">Coding Guidelines</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Other Information</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../other_information/10_external_dependencies.html">External Dependencies</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../other_information/20_glossary.html">Glossary</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../other_information/30_gui_plugins.html">GUI Plugins</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../other_information/40_license.html">License</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../index.html">openPASS</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../../index.html" class="icon icon-home" aria-label="Home"></a></li>
          <li class="breadcrumb-item"><a href="../30_configs_in_depth.html">Configs in Depth</a></li>
      <li class="breadcrumb-item active">Scenario API Support</li>
      <li class="wy-breadcrumbs-aside">
            <a href="../../_sources/user_guide/configs/scenario_api_support.rst.txt" rel="nofollow"> View page source</a>
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <section id="scenario-api-support">
<span id="id1"></span><h1>Scenario API Support<a class="headerlink" href="#scenario-api-support" title="Link to this heading"></a></h1>
<section id="igeometryhelper">
<h2>IGeometryHelper<a class="headerlink" href="#igeometryhelper" title="Link to this heading"></a></h2>
<table class="docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Function</p></th>
<th class="head"><p>Status</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>TranslateGlobalPositionLocally</p></td>
<td><p>✔️ Implemented</p></td>
</tr>
<tr class="row-odd"><td><p>TransformPolylinePointsFromWorldToLocal</p></td>
<td><p>✔️ Implemented</p></td>
</tr>
<tr class="row-even"><td><p>TransformPositionFromWorldToLocal</p></td>
<td><p>✔️ Implemented</p></td>
</tr>
<tr class="row-odd"><td><p>—————————————</p></td>
<td><p>————–</p></td>
</tr>
</tbody>
</table>
</section>
<section id="ienvironment">
<h2>IEnvironment<a class="headerlink" href="#ienvironment" title="Link to this heading"></a></h2>
<table class="docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Function</p></th>
<th class="head"><p>Status</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>CreateMap</p></td>
<td><p>✔️ Implemented</p></td>
</tr>
<tr class="row-odd"><td><p>AddEntityToController</p></td>
<td><p>✔️ Implemented</p></td>
</tr>
<tr class="row-even"><td><p>RemoveControllerFromEntity</p></td>
<td><p>❌ Not yet implemented</p></td>
</tr>
<tr class="row-odd"><td><p>UpdateControlStrategies</p></td>
<td><p>Currently ControlStrategies are always overwritten</p></td>
</tr>
<tr class="row-even"><td><p>HasControlStrategyGoalBeenReached</p></td>
<td><p>❌ Not yet implemented (always returns true)</p></td>
</tr>
<tr class="row-odd"><td><p>GetQueryService</p></td>
<td><p>✔️ Implemented</p></td>
</tr>
<tr class="row-even"><td><p>GetConverter</p></td>
<td><p>✔️ Implemented</p></td>
</tr>
<tr class="row-odd"><td><p>GetGeometryHelper</p></td>
<td><p>✔️ Implemented</p></td>
</tr>
<tr class="row-even"><td><p>GetEntityRepository</p></td>
<td><p>✔️ Implemented</p></td>
</tr>
<tr class="row-odd"><td><p>GetControllerRepository</p></td>
<td><p>✔️ Implemented</p></td>
</tr>
<tr class="row-even"><td><p>SetDateTime</p></td>
<td><p>❌ Not yet implemented</p></td>
</tr>
<tr class="row-odd"><td><p>GetDateTime</p></td>
<td><p>❌ Not yet implemented</p></td>
</tr>
<tr class="row-even"><td><p>GetSimulationTime</p></td>
<td><p>✔️ Implemented</p></td>
</tr>
<tr class="row-odd"><td><p>SetWeather</p></td>
<td><p>✔️ Implemented</p></td>
</tr>
<tr class="row-even"><td><p>SetRoadCondition</p></td>
<td><p>❌ Not yet implemented</p></td>
</tr>
<tr class="row-odd"><td><p>SetTrafficSignalState</p></td>
<td><p>❌ Not yet implemented</p></td>
</tr>
<tr class="row-even"><td><p>ExecuteCustomCommand</p></td>
<td><p>✔️ Implemented</p></td>
</tr>
<tr class="row-odd"><td><p>SetUserDefinedValue</p></td>
<td><p>❌ Not yet implemented</p></td>
</tr>
<tr class="row-even"><td><p>GetUserDefinedValue</p></td>
<td><p>❌ Not yet implemented (always returns nullopt)</p></td>
</tr>
<tr class="row-odd"><td><p>SetVariable</p></td>
<td><p>❌ Not yet implemented</p></td>
</tr>
<tr class="row-even"><td><p>GetVariable</p></td>
<td><p>❌ Not yet implemented (always returns nullopt)</p></td>
</tr>
<tr class="row-odd"><td><p>———————————-</p></td>
<td><p>—————————————————</p></td>
</tr>
</tbody>
</table>
</section>
<section id="icoordconverter">
<h2>ICoordConverter<a class="headerlink" href="#icoordconverter" title="Link to this heading"></a></h2>
<table class="docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Function</p></th>
<th class="head"><p>Status</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>Convert</p></td>
<td><p>Implemented for OpenDrivePosition only</p></td>
</tr>
<tr class="row-odd"><td><p>———</p></td>
<td><p>—————————————</p></td>
</tr>
</tbody>
</table>
</section>
<section id="ilanelocationqueryservice">
<h2>ILaneLocationQueryService<a class="headerlink" href="#ilanelocationqueryservice" title="Link to this heading"></a></h2>
<table class="docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Function</p></th>
<th class="head"><p>Status</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>GetLaneOrientation</p></td>
<td><p>✔️ Implemented</p></td>
</tr>
<tr class="row-odd"><td><p>GetUpwardsShiftedLanePosition</p></td>
<td><p>✔️ Implemented</p></td>
</tr>
<tr class="row-even"><td><p>IsPositionOnLane</p></td>
<td><p>✔️ Implemented</p></td>
</tr>
<tr class="row-odd"><td><p>GetLaneIdsAtPosition</p></td>
<td><p>✔️ Implemented</p></td>
</tr>
<tr class="row-even"><td><p>FindLanePoseAtDistanceFrom</p></td>
<td><p>✔️ Implemented</p></td>
</tr>
<tr class="row-odd"><td><p>GetLongitudinalLaneDistanceBetweenPositions</p></td>
<td><p>✔️ Implemented</p></td>
</tr>
<tr class="row-even"><td><p>FindRelativeLanePoseAtDistanceFrom</p></td>
<td><p>✔️ Implemented</p></td>
</tr>
<tr class="row-odd"><td><p>GetRelativeLaneId</p></td>
<td><p>✔️ Implemented</p></td>
</tr>
<tr class="row-even"><td><p>——————————————–</p></td>
<td><p>————–</p></td>
</tr>
</tbody>
</table>
</section>
<section id="icontrollerrepository">
<h2>IControllerRepository<a class="headerlink" href="#icontrollerrepository" title="Link to this heading"></a></h2>
<table class="docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Function</p></th>
<th class="head"><p>Status</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>Create</p></td>
<td><p>Implemented for ExternalControllerConfig (openPASS AgentProfile)</p></td>
</tr>
<tr class="row-odd"><td><p>Get</p></td>
<td><p>✔️ Implemented</p></td>
</tr>
<tr class="row-even"><td><p>Contains</p></td>
<td><p>✔️ Implemented</p></td>
</tr>
<tr class="row-odd"><td><p>Delete</p></td>
<td><p>❌ Not yet implemented</p></td>
</tr>
<tr class="row-even"><td><p>———</p></td>
<td><p>—————————————————————–</p></td>
</tr>
</tbody>
</table>
</section>
<section id="ientity">
<h2>IEntity<a class="headerlink" href="#ientity" title="Link to this heading"></a></h2>
<table class="docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Function</p></th>
<th class="head"><p>Status</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>GetUniqueId</p></td>
<td><p>✔️ Implemented</p></td>
</tr>
<tr class="row-odd"><td><p>SetName</p></td>
<td><p>✔️ Implemented</p></td>
</tr>
<tr class="row-even"><td><p>GetName</p></td>
<td><p>✔️ Implemented</p></td>
</tr>
<tr class="row-odd"><td><p>SetPosition</p></td>
<td><p>✔️ Implemented</p></td>
</tr>
<tr class="row-even"><td><p>GetPosition</p></td>
<td><p>✔️ Implemented</p></td>
</tr>
<tr class="row-odd"><td><p>SetVelocity</p></td>
<td><p>✔️ Implemented</p></td>
</tr>
<tr class="row-even"><td><p>GetVelocity</p></td>
<td><p>✔️ Implemented</p></td>
</tr>
<tr class="row-odd"><td><p>SetAcceleration</p></td>
<td><p>not during Init, only absolute acceleration set</p></td>
</tr>
<tr class="row-even"><td><p>GetAcceleration</p></td>
<td><p>✔️ Implemented</p></td>
</tr>
<tr class="row-odd"><td><p>SetOrientation</p></td>
<td><p>✔️ Implemented</p></td>
</tr>
<tr class="row-even"><td><p>GetOrientation</p></td>
<td><p>✔️ Implemented</p></td>
</tr>
<tr class="row-odd"><td><p>SetOrientationRate</p></td>
<td><p>not during Init</p></td>
</tr>
<tr class="row-even"><td><p>GetOrientationRate</p></td>
<td><p>✔️ Implemented</p></td>
</tr>
<tr class="row-odd"><td><p>SetOrientationAcceleration</p></td>
<td><p>not during Init</p></td>
</tr>
<tr class="row-even"><td><p>GetOrientationAcceleration</p></td>
<td><p>✔️ Implemented</p></td>
</tr>
<tr class="row-odd"><td><p>SetAssignedLaneIds</p></td>
<td><p>❌ Not yet implemented</p></td>
</tr>
<tr class="row-even"><td><p>GetAssignedLaneIds</p></td>
<td><p>❌ Not yet implemented</p></td>
</tr>
<tr class="row-odd"><td><p>SetVisibility</p></td>
<td><p>❌ Not yet implemented</p></td>
</tr>
<tr class="row-even"><td><p>GetVisibility</p></td>
<td><p>❌ Not yet implemented</p></td>
</tr>
<tr class="row-odd"><td><p>—————————</p></td>
<td><p>————————————————</p></td>
</tr>
</tbody>
</table>
</section>
<section id="ivehicle">
<h2>IVehicle<a class="headerlink" href="#ivehicle" title="Link to this heading"></a></h2>
<table class="docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Function</p></th>
<th class="head"><p>Status</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>SetProperties</p></td>
<td><p>❌ Not yet implemented</p></td>
</tr>
<tr class="row-odd"><td><p>GetProperties</p></td>
<td><p>✔️ Implemented</p></td>
</tr>
<tr class="row-even"><td><p>SetIndicatorState</p></td>
<td><p>❌ Not yet implemented</p></td>
</tr>
<tr class="row-odd"><td><p>GetIndicatorState</p></td>
<td><p>❌ Not yet implemented</p></td>
</tr>
<tr class="row-even"><td><p>——————</p></td>
<td><p>———————-</p></td>
</tr>
</tbody>
</table>
</section>
<section id="ipedestrian">
<h2>IPedestrian<a class="headerlink" href="#ipedestrian" title="Link to this heading"></a></h2>
<table class="docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Function</p></th>
<th class="head"><p>Status</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>SetProperties</p></td>
<td><p>❌ Not yet implemented</p></td>
</tr>
<tr class="row-odd"><td><p>GetProperties</p></td>
<td><p>✔️ Implemented</p></td>
</tr>
<tr class="row-even"><td><p>——————</p></td>
<td><p>———————-</p></td>
</tr>
</tbody>
</table>
</section>
<section id="istaticobject">
<h2>IStaticObject<a class="headerlink" href="#istaticobject" title="Link to this heading"></a></h2>
<p>❌ Not yet implemented</p>
</section>
<section id="ientityrepository">
<h2>IEntityRepository<a class="headerlink" href="#ientityrepository" title="Link to this heading"></a></h2>
<table class="docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Function</p></th>
<th class="head"><p>Status</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>Create (Vehicle)</p></td>
<td><p>✔️ Implemented</p></td>
</tr>
<tr class="row-odd"><td><p>Create (Pedestrian)</p></td>
<td><p>✔️ Implemented</p></td>
</tr>
<tr class="row-even"><td><p>Create (StaticObject)</p></td>
<td><p>❌ Not yet implemented</p></td>
</tr>
<tr class="row-odd"><td><p>GetHost</p></td>
<td><p>❌ Not yet implemented</p></td>
</tr>
<tr class="row-even"><td><p>Get (Name)</p></td>
<td><p>✔️ Implemented</p></td>
</tr>
<tr class="row-odd"><td><p>Get (Id)</p></td>
<td><p>✔️ Implemented</p></td>
</tr>
<tr class="row-even"><td><p>Contains</p></td>
<td><p>❌ Not yet implemented</p></td>
</tr>
<tr class="row-odd"><td><p>Delete (Name)</p></td>
<td><p>❌ Not yet implemented</p></td>
</tr>
<tr class="row-even"><td><p>Delete (Id)</p></td>
<td><p>❌ Not yet implemented</p></td>
</tr>
<tr class="row-odd"><td><p>GetEntities</p></td>
<td><p>❌ Not yet implemented</p></td>
</tr>
<tr class="row-even"><td><p>RegisterEntityCreatedCallback</p></td>
<td><p>❌ Not yet implemented</p></td>
</tr>
<tr class="row-odd"><td><p>RegisterEntityDeletedCallback</p></td>
<td><p>❌ Not yet implemented</p></td>
</tr>
<tr class="row-even"><td><p>——————————</p></td>
<td><p>———————-</p></td>
</tr>
</tbody>
</table>
</section>
</section>


           </div>
          </div>
          <footer><div class="rst-footer-buttons" role="navigation" aria-label="Footer">
        <a href="scenario.html" class="btn btn-neutral float-left" title="Scenario" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left" aria-hidden="true"></span> Previous</a>
        <a href="scenery.html" class="btn btn-neutral float-right" title="Scenery" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right" aria-hidden="true"></span></a>
    </div>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright 2025 openPASS Working Group.</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>